import { AsyncIteratorResourceLike } from "@reactive-js/ix";
import { ErrorLike, ObservableLike, ObserverLike } from "@reactive-js/rx";
import { ObservableOperatorLike } from "@reactive-js/observable";
import { SchedulerLike } from "@reactive-js/scheduler";
export interface AsyncIteratorResourceOperatorLike<TSrcReq, TSrc, TReq, T> {
    (iter: AsyncIteratorResourceLike<TSrcReq, TSrc>): AsyncIteratorResourceLike<TReq, T>;
}
export declare const lift: <TReq, T, TA>(operator: ObservableOperatorLike<T, TA>) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, TA>;
export declare const liftReq: <TReq, T, TReqA>(operator: (dispatcher: (req: TReq) => void) => (ref: TReqA) => void) => AsyncIteratorResourceOperatorLike<TReq, T, TReqA, T>;
export declare const concatAll: <TReq, T>(maxBufferSize?: number) => AsyncIteratorResourceOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const distinctUntilChanged: <TReq, T>(equals?: ((a: T, b: T) => boolean) | undefined) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const endWith: <TReq, T>(value: T, ...values: T[]) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const exhaust: <TReq, T>() => AsyncIteratorResourceOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const ignoreElements: <TReq, TA, TB>() => AsyncIteratorResourceOperatorLike<TReq, TA, TReq, TB>;
export declare const keep: <TReq, T>(predicate: (data: T) => boolean) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const map: <TReq, TA, TB>(mapper: (data: TA) => TB) => AsyncIteratorResourceOperatorLike<TReq, TA, TReq, TB>;
export declare const mergeAll: <TReq, T>(options?: {
    maxBufferSize?: number | undefined;
    maxConcurrency?: number | undefined;
} | undefined) => AsyncIteratorResourceOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const observe: <TReq, T>(observer: ObserverLike<T>) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const onComplete: <TReq, T>(onComplete: (err?: ErrorLike | undefined) => void) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const onError: <TReq, T>(onError: (err: unknown) => void) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const onNext: <TReq, T>(onNext: (next: T) => void) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const repeat: <TReq, T>(predicate?: number | ((count: number) => boolean) | undefined) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const retry: <TReq, T>(predicate?: ((count: number, error: unknown) => boolean) | undefined) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const scan: <TReq, T, TAcc>(scanner: (acc: TAcc, next: T) => TAcc, initialValue: () => TAcc) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, TAcc>;
export declare const share: <TReq, T>(scheduler: SchedulerLike, replayCount?: number | undefined) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const startWith: <TReq, T>(value: T, ...values: T[]) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const subscribeOn: <TReq, T>(scheduler: SchedulerLike) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const switchAll: <TReq, T>() => AsyncIteratorResourceOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const take: <TReq, T>(count: number) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const takeLast: <TReq, T>(count: number) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const takeWhile: <TReq, T>(predicate: (next: T) => boolean) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const throttle: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const throttleTime: <TReq, T>(duration: number) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const throttleFirst: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const throttleFirstTime: <TReq, T>(duration: number) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const throttleLast: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const throttleLastTime: <TReq, T>(duration: number) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const timeout: <TReq, T>(duration: number) => AsyncIteratorResourceOperatorLike<TReq, T, TReq, T>;
export declare const withLatestFrom: <TReq, TA, TB, TC>(other: ObservableLike<TB>, selector: (a: TA, b: TB) => TC) => AsyncIteratorResourceOperatorLike<TReq, TA, TReq, TC>;
//# sourceMappingURL=index.d.ts.map